<template>
  <Component :is="pageLayoutComponentName">
    <template #header>
      <PageHeader
        v-if="hasPageHeader === true"
        :abstract="abstract"
        :subtitle="subtitle"
        :title="title"
      />
    </template>

    <template #content-primary>
      <slot name="content-colPos0" />
    </template>

    <template #content-secondary>
      <slot name="content-colPos1" />
    </template>
  </Component>
</template>

<script>
import PageHeader from './PageHeader'
import PageLayout from './PageLayout/PageLayout'
import PageLayoutTwoColumn from './PageLayout/PageLayoutTwoColumn'

export default {
  name: 'ContentProcessor',

  components: {
    PageHeader,
    PageLayout,
    PageLayoutTwoColumn
  },

  props: {
    /**
     * The abstract of the page.
     */
    abstract: {
      type: String,
      default: undefined
    },

    /**
     * The layout of the page.
     */
    layout: {
      type: String,
      required: true
    },

    /**
     * The subtitle of the page.
     */
    subtitle: {
      type: String,
      default: undefined
    },

    /**
     * The title of the page.
     */
    title: {
      type: String,
      default: undefined
    }
  },

  computed: {
    hasPageHeader () {
      return (
        !!this.abstract === true ||
        !!this.subtitle === true ||
        !!this.title === true
      )
    },

    pageLayoutComponentName () {
      return this.layout === 'layout-1' ? 'PageLayoutTwoColumn' : 'PageLayout'
    }
  }
}
</script>
